function K2BGridFilters(JQuery) {
  this.$ = JQuery;
  var uc = this;
  this.columnOrder = [];

  // Databinding for property GridOrders
  this.SetGridColumns = function (data) {
    ///UserCodeRegionStart:[SetGridColumns] (do not remove this comment.)
    this.GridColumns = data;
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  // Databinding for property GridColumns
  this.GetGridColumns = function () {
    ///UserCodeRegionStart:[GetGridColumns] (do not remove this comment.)
    return this.GridColumns;
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  this.show = function () {
    if (this.GridColumns != undefined) {
      var that = this;
      this.gridTable = this.$('table[id="' + that.GetGridTableName(that.GridControlName).toLowerCase() + '" i]');

      for (i = 0; this.GridColumns[i] != undefined; i++) {
        columnData = this.GridColumns[i];
        var zeroBasedIndex = columnData.GridColumnIndex - 1;
        var column = this.gridTable.find('th.K2BT_ColumnWithFilter:eq(' + zeroBasedIndex + ')');

        var span = that.$(column).children('span.K2BT_ColumnFilterButton');
        if (span.length == 0) {
          span = that.$("<span class='K2BT_ColumnFilterButton' />");
          that.$(column).append(span);
          section = columnData.ColumnFilterSectionInternalName;
          that.$(span).click(
            {
              section: section,
              span: span,
            },
            function (e) {
              sectionName = e.data.section;
              var currentSpan = e.data.span;

              uc.$(currentSpan).closest('tr').children('th').removeClass('K2BT_ColumnWithFilterOpen');

              that.$('#' + sectionName).toggle();

              if (that.$('#' + sectionName).filter(':visible').length > 0) uc.$(currentSpan).closest('th').addClass('K2BT_ColumnWithFilterOpen');

              that.$(".K2BT_GridColumnFilterSection[id != '" + sectionName + "']").hide();
              that.FixPosition(sectionName, currentSpan);
              e.stopPropagation();
            },
          );
          that.$(window).scroll(
            {
              section: section,
              span: span,
            },
            function (e) {
              sectionName = e.data.section;
              var currentSpan = e.data.span;
              that.FixPosition(sectionName, currentSpan);
            },
          );
        }

        this.$('body').append(that.$('#' + columnData.ColumnFilterSectionInternalName));

        this.FixPosition(columnData.ColumnFilterSectionInternalName, span);
        this.UpdateStatus(columnData.ContainsActiveFilter, column);
      }
    }

    if (this.EnableColumnOrdering) {
      $(this.gridTable)
        .find('th:not(.ActionColumn)')
        .each(function (i, item) {
          $(item).attr('draggable', true);
        });
      var maxindex = parseInt($(this.gridTable).find('th:last-child').attr('data-colindex'));

      if (this.columnOrder.length == 0) {
        if (this.ColumnOrderString == '' || this.ColumnOrderString == null || this.ColumnOrderString == undefined) {
          this.columnOrder = [...Array(maxindex).keys()];
        } else {
          this.columnOrder = this.ColumnOrderString.split(',').map(i => parseInt(i));
          for (var i = 0; i <= maxindex; i++) {
            if (this.columnOrder.indexOf(i) == -1) this.columnOrder.push(i);
          }
        }
      }

      this.ColumnOrderString = this.columnOrder.join(',');

      /*
        .K2BT_GridColumnHovering {
            border-left:3px dashed #ccc;
        }

        .K2BT_GridColumnHoverTarget{
            background-color:#f5f5f5;
        }
        */

      $(this.gridTable)
        .find('th:not(.ActionColumn)')
        .on('dragstart', function (e) {
          e.originalEvent.dataTransfer.effectAllowed = 'all';
          var position = $(this).attr('data-colindex');
          e.originalEvent.dataTransfer.setData('originalPosition', position);

          $(that.gridTable)
            .find('th:not(.ActionColumn)')
            .filter(v => v != this)
            .addClass('K2BT_GridColumnHoverTarget');
        })
        .on('dragover', function (e) {
          e.originalEvent.dataTransfer.dropEffect = 'move';
          e.preventDefault();
          e.originalEvent.preventDefault();
          $(this).addClass('K2BT_GridColumnHovering');
          var position = $(this).attr('data-colindex');
          if (e.preventDefault) {
            e.preventDefault(); // Necessary. Allows us to drop.
          }
          return false;
        })
        .on('dragenter', function (e) {
          e.preventDefault();
          e.originalEvent.preventDefault();
          e.stopPropagation();
          $(this).addClass('K2BT_GridColumnHovering');
        })
        .on('dragleave', function (e) {
          $(this).removeClass('K2BT_GridColumnHovering');
          return false;
        })
        .on('drop dragdrop', function (e) {
          e.stopImmediatePropagation();

          $(uc.gridTable).find('th').removeClass('K2BT_GridColumnHovering');
          $(uc.gridTable).find('th').removeClass('K2BT_GridColumnHoverTarget');
          var dst = parseInt($(this).attr('data-colindex'));
          var orgn = e.originalEvent.dataTransfer ? parseInt(e.originalEvent.dataTransfer.getData('originalPosition')) : NaN;
          if (!Number.isNaN(orgn) && !Number.isNaN(dst)) {
            var from = that.columnOrder.indexOf(orgn);
            var to = that.columnOrder.indexOf(dst);

            console.log('From: ' + from);
            console.log('To: ' + to);

            if (from < to) that.columnOrder.splice(to - 1, 0, that.columnOrder.splice(from, 1)[0]);
            else that.columnOrder.splice(to, 0, that.columnOrder.splice(from, 1)[0]);
            that.ColumnOrderString = that.columnOrder.join(',');

            if (that.ColumnOrderChanged) that.ColumnOrderChanged();

            that.reorderColumns();
          }
          return false;
        });

      this.reorderColumns();
    }
    ///UserCodeRegionEnd: (do not remove this comment.)
  };
  ///UserCodeRegionStart:[User Functions] (do not remove this comment.)

  this.reorderColumns = function () {
    var that = this;
    $(this.gridTable)
      .find('tr')
      .each(function (i, tr) {
        var cols = $(tr).children('th,td');
        cols.detach();

        $(tr).append(
          $.map(that.columnOrder, function (v) {
            return cols.filter(function (i, col) {
              return $(col).attr('data-colindex') == v;
            });
          }),
        );
      });
  };

  this.UpdateStatus = function (containsFilter, column) {
    if (containsFilter) {
      this.$(column).addClass('K2BT_ColumnWithActiveFilter');
    } else {
      this.$(column).removeClass('K2BT_ColumnWithActiveFilter');
    }
  };

  this.FixPosition = function (sectionName, span) {
    var section = this.$('#' + sectionName);
    th = this.$(span).closest('th');
    if (th.attr('data-k2btools-widthset') == 'true' && th.css('width').length > 0) {
      th.attr('data-k2btools-widthset', 'true');
      th.css({ width: parseFloat(th.css('width')) + span.outerWidth() });
    }

    var width = this.$('#' + sectionName).outerWidth();

    section.css({ top: th.offset().top + th.height() });

    var leftValue = th.offset().left - width + th.outerWidth();
    if (leftValue > 0) section.css({ left: leftValue });
    else section.css({ left: leftValue + width });

    var selectedItem = this.$('#' + sectionName + ' .K2BT_DateRangeItemSelected');
    if (selectedItem.length > 0) {
      var offset = selectedItem.offset().top - section.offset().top;
      section.scrollTop(offset);
    }
  };

  this.GetGridTableName = function (controlName) {
    return controlName + 'ContainerTbl';
  };

  this.clickHandler = function (e) {
    if (
      !uc.$(e.target).hasClass('K2BT_ColumnFilterButton') &&
      uc.$(e.target).closest('.K2BT_GridColumnFilterSection').length == 0 &&
      uc.$(e.target).closest('.calendar').length == 0
    ) {
      uc.$('.K2BT_GridColumnFilterSection').hide();
      uc.$('.K2BT_ColumnWithFilterOpen').removeClass('K2BT_ColumnWithFilterOpen');
    }
  };

  gx.fx.obs.addObserver('grid.onafterrender', this, this.show, { single: false, unique: true });
  uc.$('a, img, button, html').on('click', this.clickHandler);

  ///UserCodeRegionEnd: (do not remove this comment.):
}
