'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-15d2a36c.js');
const utils = require('./utils-aa13c8b6.js');

const K2btCalendarActionMenu = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.actionClicked = index.createEvent(this, "actionClicked", 7);
    this.actions = [];
    this.isOpen = false;
  }
  toggleMenu() {
    this.isOpen = !this.isOpen;
  }
  executeAction(action) {
    this.isOpen = false;
    this.actionClicked.emit(action.id);
  }
  closeMenu(ev) {
    if (this.isOpen && this.quickDaySelectorContainer && !this.quickDaySelectorContainer.contains(ev.target))
      this.isOpen = false;
  }
  render() {
    var _a, _b;
    const menuClass = `K2BT_CalendarActionMenu ${this.isOpen ? 'open' : ''}`;
    return ((_b = (_a = this.actions) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0 ? (index.h("div", { class: menuClass, ref: c => (this.quickDaySelectorContainer = c) }, index.h("span", { class: "K2BT_CalendarActionMenu_ToggleButton", onClick: e => {
        e.stopPropagation();
        this.toggleMenu();
      } }), index.h("div", { class: "K2BT_CalendarActionMenuContents" }, this.isOpen && (index.h("ul", { class: "K2BT_CalendarActionMenu_Dropdown" }, this.actions.map(action => (index.h("li", { onClick: e => {
        e.stopPropagation();
        this.executeAction(action);
      } }, index.h("img", { class: 'K2BT_CalendarActionMenu_Image GX_Image_' + action.imageName + '_Class', src: action.imageUrl, alt: utils.LanguageUtils.getTranslatedMessage(action.name) }), index.h("span", null, utils.LanguageUtils.getTranslatedMessage(action.name)))))))))) : ('');
  }
};

exports.k2bt_calendar_action_menu = K2btCalendarActionMenu;
